//Classe Curso
function Curso(codigo,nome)
{
	this.codigo = codigo;
	this.nome = nome;

	this.listaAluno = [];

	this.getCodigo = getCodigo;
	function getCodigo()
	{
		return this.codigo;
	}

	this.getNome = getNome;
	function getNome()
	{
		return this.nome;
	}

	this.getListaAluno = getListaAluno;
	function getListaAluno()
	{
		return this.listaAluno;
	}

	this.setListaAluno = setListaAluno;
	function setListaAluno(aluno)
	{
		this.listaAluno.push(aluno);
	}

	this.toString = toString;
	function toString()
	{
		return "O código do curso é "+this.codigo+ " e o nome é " +this.nome + "\n";
	}

	//MÉTODO QUE RETORNA A MÉDIA FINAL DOS ALUNOS DE UM CURSO EM UMA DADA DISCIPLINA
	this.getMediaFinal = getMediaFinal;
	function getMediaFinal(d,ListaAvaliacoes)
	{
		var mediaTurma = 0.0;
		var totalTurma = 0.0;

		this.listaAluno.forEach(function(a)
		{					
			for(var i = 0 ; i < a.getDisciplinas().length ; i++)
			{
				if(a.getDisciplinas()[i] == d.getCodigo())
				{
					mediaTurma += a.getmediafinal(d);
					totalTurma++ ;
				}
			}
		});		
		return  mediaTurma/totalTurma;
	}

	//MÉTODO QUE RETORNA O PERCENTUAL DE APROVADOS DE UM CURSO EM UMA DADA DISCIPLINA
	this.getPercentualdeAprovados = getPercentualdeAprovados;
	function getPercentualdeAprovados(d,ListaAvaliacoes)
	{
		var percentual = 0.0;
		var totalpercentual = 0.0;
		
		this.listaAluno.forEach(function(a)
		{
			a.getDisciplinas().forEach(function(d1)
			{
				if(d1 == d.getCodigo())
				{
					if(a.getmediafinal(d) >= 5.0)
					{
						percentual++;
						totalpercentual++;
					}
					else
					{
						totalpercentual++;
					}
				}
			});
		});	
		
		return percentual/totalpercentual;
	}	
};

//Classe Disciplina
function Disciplina(codigo,nome)
{
	this.codigo = codigo;
	this.nome = nome;

	this.listaAvaliacao = [];
	this.listaAluno = [];
	this.listaCurso = [];


	this.getCodigo = getCodigo;
	function getCodigo()
	{
		return this.codigo;
	}

	this.getNome = getNome;
	function getNome()
	{
		return this.nome;
	}

	this.getListaCurso = getListaCurso;
	function getListaCurso()
	{
		return this.listaCurso;
	}

	this.setListaCurso = setListaCurso;
	function setListaCurso(curso)
	{
		this.listaCurso.push(curso);
	}

	this.getListaAluno = getListaAluno;
	function getListaAluno()
	{
		return this.listaAluno;
	}

	this.setListaAluno = setListaAluno;
	function setListaAluno(aluno)
	{
		this.listaAluno.push(aluno);
	}

	this.getListaAvaliacao = getListaAvaliacao;
	function getListaAvaliacao()
	{
		return this.listaAvaliacao;
	}

	this.setlistaAvaliacao = setlistaAvaliacao;
	function setlistaAvaliacao(avaliacao)
	{
		this.listaAvaliacao.push(avaliacao);
	}

	this.toString = toString;
	function toString()
	{
		return "O código da disciplina é "+this.codigo+ " e o nome é " +this.nome+ "\n" ;
	}
};

//Classe Avaliacao
function Avaliacao(codigoDisciplina,codigoAvaliacao,nome,peso,tipo,data)
{
	this.codigoDisciplina = codigoDisciplina;
	this.codigoAvaliacao = codigoAvaliacao;
	this.nome = nome;
	this.peso = peso;
	this.tipo = tipo;
	this.data = data;
	this.tamanhoMaximoGrupo = 0;

	this.setTamanhoMaximoGrupo = setTamanhoMaximoGrupo;
	function setTamanhoMaximoGrupo(tamanhoMaximoGrupo)
	{
		this.tamanhoMaximoGrupo = tamanhoMaximoGrupo;
	}

	this.getCodigoDisciplina = getCodigoDisciplina;
	function getCodigoDisciplina()
	{
		return this.codigoDisciplina;
	}

	this.getCodigoAvaliacao = getCodigoAvaliacao;
	function getCodigoAvaliacao()
	{
		return this.codigoAvaliacao;
	}

	this.getNome = getNome;
	function getNome()
	{
		return this.nome;
	}

	this.getPeso = getPeso;
	function getPeso()
	{
		return this.peso;
	} 

	this.getTipo = getTipo;
	function getTipo()
	{
		return this.tipo;
	}

	this.getData = getData;
	function getData()
	{
		return this.data;
	} 

	//MÉTODO QUE RETORNA A MÉDIA DOS ALUNOS EM UMA DADA AVALIAÇÃO
	this.mediaAlunos = mediaAlunos;
	function mediaAlunos()
	{
		var media = 0.0;
		var total = 0.0;
		var codAva = this.codigoAvaliacao;

		listaNotas.forEach(function(n)
		{
			if(n.getCodigoAvaliacao() == codAva)
			{
				media += n.getNota();
				total++;
			}
		});
	
		return(media/total);
	}
};

//Classe Aluno
function Aluno(matricula,nome,disciplinas,tipo,indicacaoCurso)
{
	this.matricula = matricula;
	this.nome = nome;
	this.disciplinas = disciplinas.split(',');
	this.tipo = tipo;
	this.codigoCurso = 0;
	this.indicacaoCurso = "";

	this.listanota = [];

	//RETIRA OS ESPAÇOS AO REDOR DA VÍRGULA
	for(var i=0; i<this.disciplinas.length; i++)
	{
		this.disciplinas[i] = this.disciplinas[i].trim();
	}

	if(tipo == "G")
	{
		this.codigoCurso = indicacaoCurso;
	}
	else
	{
		this.indicacaoCurso = indicacaoCurso;
	}

	this.getMatricula = getMatricula;
	function getMatricula()
	{
		return this.matricula;
	}

	this.getNome = getNome;
	function getNome()
	{
		return this.nome;
	}

	this.getDisciplinas = getDisciplinas;
	function getDisciplinas()
	{
		return this.disciplinas;
	}

	this.getTipo = getTipo;
	function getTipo()
	{
		return this.tipo;
	}

	this.getCodigoCurso = getCodigoCurso;
	function getCodigoCurso()
	{
		return this.codigoCurso;
	}

	this.getIndicacaoCurso = getIndicacaoCurso;
	function getIndicacaoCurso()
	{
		return this.indicacaoCurso;
	}

	this.getListanota = getListanota;
	function getListanota()
	{
		return this.listanota;
	}

	this.setListanota = setListanota;
	function setListanota(nota)
	{
		this.listanota.push(nota)
	}

	//VERIFICA SE O ALUNO FAZ A DISCIPLINA
	this.alunodisciplina = alunodisciplina;
	function alunodisciplina(disciplina)
	{
		for(var i=0; i<this.disciplinas.length; i++)
		{
			if(this.disciplinas[i] == disciplina.getCodigo())
			{
				return true;
			}
		}
		return false;
	}

	//MÉTODO QUE RETORNA A MÉDIA PARCIAL DO ALUNO EM UMA DADA DISICPLINA
	this.getmediaparcial = getmediaparcial;
	function getmediaparcial(d)
	{	
		var mediaparcial = 0.0;
		var total = 0.0;
		
		this.listanota.forEach(function(n)
		{
			var ava = mapAvaliacoes.get(n.getCodigoAvaliacao());
			
			if(ava.getTipo() != "F" && ava.getCodigoDisciplina() == d.getCodigo())
			{
				mediaparcial += n.getNota() * ava.getPeso();
				total += ava.getPeso();
			}		
		});
		
		return mediaparcial/total;
	}

	//MÉTODO QUE VERIFICA SE ALUNO PRECISA FAZER FINAL, OU SEJA, MÉDIA PARCIAL MENOR QUE 7
	this.fazFinalDisciplina	= fazFinalDisciplina;
	function fazFinalDisciplina(d)
	{
		var media = this.getmediaparcial(d);
		return media < 7.0;
	}

	//MÉTODO QUE RETORNA A NOTA FINAL DO ALUNO
	this.getNotaFinal = getNotaFinal;
	function getNotaFinal(d)
	{	
		var pfinal = 0.0;
		
		this.listanota.forEach(function(n)
		{
			var ava = mapAvaliacoes.get(n.getCodigoAvaliacao());
			if(ava.getTipo() == "F" && ava.getCodigoDisciplina() == d.getCodigo())
			{
				pfinal = n.getNota();
			}		
		});
		
		return pfinal;
	}

	//MÉTODO QUE RETORNA A MÉDIA FINAL DO ALUNO EM UMA DADA DISCIPLINA
	this.getmediafinal = getmediafinal;
	function getmediafinal(d)
	{ 
		if(this.fazFinalDisciplina(d))
		{
			return (this.getmediaparcial(d) + this.getNotaFinal(d))/2.0;
		}
		else
		{
			return this.getmediaparcial(d);
		}
	}

};

//Classe nota
function Nota(codigoAvaliacao,matriculasAlunos,nota)
{
	this.codigoAvaliacao = codigoAvaliacao;
	this.matriculasAlunos = matriculasAlunos.split(',');
	this.nota = nota;

	//RETIRA OS ESPAÇOS AO REDOR DA VÍRGULA
	for(var i=0; i<this.matriculasAlunos.length; i++)
	{
		this.matriculasAlunos[i] = this.matriculasAlunos[i].trim();
	}

	this.getCodigoAvaliacao = getCodigoAvaliacao;
	function getCodigoAvaliacao()
	{
		return this.codigoAvaliacao;
	}

	this.getMatriculasAlunos = getMatriculasAlunos;
	function getMatriculasAlunos()
	{
		return this.matriculasAlunos;
	} 

	this.getNota = getNota;
	function getNota()
	{
		return this.nota;
	}
};