//LEITOR DE ARQUIVOS
var leitorDeCSV = new FileReader();

//VETORES E MAPAS GLOBAIS
var listaCursos = [];
var listaDisciplinas = [];
var listaAvaliacoes = [];
var listaAlunos = [];
var listaNotas = [];

var mapCursos = new Map();
var mapAvaliacoes = new Map();
var mapAlunos = new Map();
 
 //FUNÇÃO QUE SELECIONA OS ARQUIVOS
function pegaCSV(inputFile) 
{
	var file = inputFile.files[0];

	//SELECIONA E CHAMA A FUNÇÃO DE LEITURA
	if(file.name == "cursos.csv")
	{
		leitorDeCSV.readAsText(file);
		leitorDeCSV.onload = lerCursos;
	}
	else if(file.name == "disciplinas.csv")
	{
		leitorDeCSV.readAsText(file);
		leitorDeCSV.onload = lerDisciplinas;
	}
	else if(file.name == "avaliacoes.csv")
	{
		leitorDeCSV.readAsText(file);
		leitorDeCSV.onload = lerAvaliacoes;
	}
	else if(file.name == "alunos.csv")
	{
		leitorDeCSV.readAsText(file);
		leitorDeCSV.onload = lerAlunos;
	}
	else if(file.name == "notas.csv")
	{
		leitorDeCSV.readAsText(file);
		leitorDeCSV.onload = lerNotas;
	}
	
}

function lerCursos(evt) 
{
	//QUEBRA O ARQUIVO EM LINHAS
	var fileArr = evt.target.result.split('\n');
	var strDiv = '<table>';
 
 	//PERCORRE CADA LINHA DO ARQUIVO
	for (var i=1; i<(fileArr.length-1); i++) 
	{
		//QUEBRA A LINHA EM CÉLULAS
		strDiv += '<tr>';
		var celula = fileArr[i].split(';');
		
		//CRIA UM NOVO CURSO
		var c = new Curso(parseInt(celula[0]),celula[1]);

		//ADICIONA O CURSO NO VETOR E NO MAPA
		listaCursos.push(c);
		mapCursos.set(celula[0],c);

		//TERMINA DE MONTAR A TABELA
		for (var j=0; j<celula.length; j++) 
		{
			strDiv += '<td>'+celula[j].trim()+'</td>';			
		}
		
		strDiv += '</tr>';
	}
 
 	//IMPRIME A TABELA NA PÁGINA HTML
	strDiv += '</table>';
	var CSVsaida = document.getElementById('CSVsaida');
	CSVsaida.innerHTML = strDiv;

}

function lerDisciplinas(evt) 
{
	//QUEBRA O ARQUIVO EM LINHAS
	var fileArr = evt.target.result.split('\n');
	var strDiv = '<table>';
 
 	//PERCORRE CADA LINHA DO ARQUIVO
	for (var i=1; i<(fileArr.length-1); i++) 
	{
		//QUEBRA A LINHA EM CÉLULAS
		strDiv += '<tr>';
		var celula = fileArr[i].split(';');
		
		//CRIA UMA NOVA DISCIPLINA
		var d = new Disciplina(celula[0],celula[1]);

		//ADICIONA A DISCIPLINA NO VETOR
		listaDisciplinas.push(d);

		//TERMINA DE MONTAR A TABELA
		for (var j=0; j<celula.length; j++) 
		{
			strDiv += '<td>'+celula[j].trim()+'</td>';			
		}
		
		strDiv += '</tr>';
	}
 
 	//IMPRIME A TABELA NA PÁGINA HTML
	strDiv += '</table>';
	var CSVsaida = document.getElementById('CSVsaida');
	CSVsaida.innerHTML = strDiv;

}

function lerAvaliacoes(evt) 
{
	//QUEBRA O ARQUIVO EM LINHAS
	var fileArr = evt.target.result.split('\n');
	var strDiv = '<table>';
 
 	//PERCORRE CADA LINHA DO ARQUIVO
	for (var i=1; i<(fileArr.length-1); i++) 
	{
		//QUEBRA A LINHA EM CÉLULAS
		strDiv += '<tr>';
		var celula = fileArr[i].split(';');
		
		//CRIA UMA NOVA AVALIAÇÃO
		var p = new Avaliacao(celula[0],celula[1],celula[2],parseFloat(celula[3].replace(',', '.')),celula[4],celula[5]);
		
		//VERIFICA SE É UM TRABALHO
		if(celula[4] == "T")
		{
			p.setTamanhoMaximoGrupo(celula[6]);
		}

		//ADICIONA A AVALIAÇÃO NO VETOR E NO MAPA
		listaAvaliacoes.push(p);
		mapAvaliacoes.set(celula[1],p);

		//TERMINA DE MONTAR A TABELA
		for (var j=0; j<celula.length; j++) 
		{
			strDiv += '<td>'+celula[j].trim()+'</td>';			
		}
		
		strDiv += '</tr>';
	}
 
 	//IMPRIME A TABELA NA PÁGINA HTML
	strDiv += '</table>';
	var CSVsaida = document.getElementById('CSVsaida');
	CSVsaida.innerHTML = strDiv;

}

function lerAlunos(evt) 
{
	//QUEBRA O ARQUIVO EM LINHAS
	var fileArr = evt.target.result.split('\n');
	var strDiv = '<table>';
 
 	//PERCORRE CADA LINHA DO ARQUIVO
	for (var i=1; i<(fileArr.length-1); i++) 
	{
		//QUEBRA A LINHA EM CÉLULAS
		strDiv += '<tr>';
		var celula = fileArr[i].split(';');
		
		//CRIA UM NOVO ALUNO
		var a = new Aluno(parseInt(celula[0]),celula[1],celula[2],celula[3],celula[4]);

		//ADICIONA O ALUNO NO VETOR E NO MAPA
		listaAlunos.push(a);
		mapAlunos.set(celula[0],a);

		//TERMINA DE MONTAR A TABELA
		for (var j=0; j<celula.length; j++) 
		{
			strDiv += '<td>'+celula[j].trim()+'</td>';			
		}
		
		strDiv += '</tr>';
	}
 
 	//IMPRIME A TABELA NA PÁGINA HTML
	strDiv += '</table>';
	var CSVsaida = document.getElementById('CSVsaida');
	CSVsaida.innerHTML = strDiv;
	
}

function lerNotas(evt) 
{
	//QUEBRA O ARQUIVO EM LINHAS
	var fileArr = evt.target.result.split('\n');
	var strDiv = '<table>';
 
 	//PERCORRE CADA LINHA DO ARQUIVO
	for (var i=1; i<(fileArr.length-1); i++) 
	{
		//QUEBRA A LINHA EM CÉLULAS
		strDiv += '<tr>';
		var celula = fileArr[i].split(';');
		
		//CRIA UMA NOVA NOTA
		var n = new Nota(celula[0],celula[1],parseFloat(celula[2].replace(',', '.')));

		//ADICIONA A NOTA NO VETOR
		listaNotas.push(n);

		//TERMINA DE MONTAR A TABELA
		for (var j=0; j<celula.length; j++) 
		{
			strDiv += '<td>'+celula[j].trim()+'</td>';			
		}
		
		strDiv += '</tr>';
	}
 
 	//IMPRIME A TABELA NA PÁGINA HTML
	strDiv += '</table>';
	var CSVsaida = document.getElementById('CSVsaida');
	CSVsaida.innerHTML = strDiv;
	
}


function ajudaNaImpressao()
{
	//CRIAMOS OS CURSOS MESTRADO E DOUTORADO PARA A ESTATISTICA DE DISCIPLINAS
	var c1 = new Curso(0,"Mestrado");
	var c2 = new Curso(0,"Doutorado");

	//E ADCIONAMOS AO MAPA DE CURSOS
	mapCursos.set("M", c1);
	mapCursos.set("D", c2);

	// NESSE FOR PASSAMOS POR TODAS AS DISCIPLINAS
	listaDisciplinas.forEach(function(d)
	{
		//PARA CADA AVALIAÇÃO COLOCAREMOS ELA NUMA LISTA DE AVALIAÇÕES DA DISCIPLINA
		listaAvaliacoes.forEach(function(a)
		{
			//SE ESTA PERTENCE A DISCIPLINA
			if(d.getCodigo() == a.getCodigoDisciplina())
			{
				d.setlistaAvaliacao(a);
			}
		});

		//E PRA CADA ALUNO O COLOCAREMOS NUMA LISTA DE ALUNOS DA DISCIPLINA
		mapAlunos.forEach(function(valor,chave)
		{
			var aluno = valor;

			//SE FOR UM ALUNO DESTA DISCIPLINA 
			if(aluno.alunodisciplina(d))
			{
				d.setListaAluno(aluno);
				
				//E CAPTURAREMOS TAMBÉM O CURSO DO ALUNO E COLOCAREMOS O CURSO NUMA LISTA DE CURSOS DA DISCIPLINA
				//SE O METODO GETCODIGOCURSO FOR MAIOR QUE ZERO O ALUNO É DA GRADUAÇÃO
				if(aluno.getCodigoCurso() > 0)
				{
					//CAPTURANDO O CURSO DO ALUNO PELO CÓDIGO DO CURSO
					var c = mapCursos.get(aluno.getCodigoCurso());
					
					d.setListaCurso(c);
				
					//E COLOCAMOS O ALUNO NUMA LISTA DE ALUNOS DO CURSO
					c.getListaAluno().push(aluno);
				}
				//SE O METODO GETCODIGOCURSO FOR IGUAL QUE ZERO O ALUNO É DA PÓS-GRADUAÇÃO
				else if(aluno.getCodigoCurso() == 0)
				{
					//CAPTURANDO O CURSO DO ALUNO PELA INDICAÇÃO DO CURSO
					var c = mapCursos.get(aluno.getIndicacaoCurso());
				
					d.setListaCurso(c);
				
					//E COLOCAMOS O ALUNO NUMA LISTA DE ALUNOS DO CURSO
					c.getListaAluno().push(aluno);				}
			}
		},mapAlunos);
	});

	//PARA CADA ALUNO
	mapAlunos.forEach(function(valor,chave)
	{
		var aluno = valor;

		//E PRA CADA NOTA
		listaNotas.forEach(function(n)
		{
			for(var i = 0 ; i < n.getMatriculasAlunos().length ; i++)
			{
				if(aluno.getMatricula() == n.getMatriculasAlunos()[i])
				{
					//COLOCAREMOS AS NOTAS DO ALUNO EM UMA LISTA DE NOTAS
					aluno.setListanota(n);
				}
			}
		});
	},mapAlunos);

}

//AQUI GERAMOS O RELATÓRIO DE ESTATÍSTICA POR AVALIAÇÕES
function estatisticaAvaliacao()
{
	//ARMAZENA O CONTEÚDO DO ARQUIVO.CSV
	var arquivoCSV = "data:text/csv;charset=utf-8,"; 
	
	//ADICIONA O CABEÇALHO NO ARQUIVO.CSV
	console.log("Disciplina;Código;Avaliação;Data;Média");
	
	arquivoCSV += ("Disciplina;Código;Avaliação;Data;Média\n");
	
	//ORDENAÇÃO DE LISTA DE DISCIPLINAS
	listaDisciplinas = listaDisciplinas.sort(function(a,b) 
	{
		if(a.getCodigo() < b.getCodigo())
		{
			return -1;
		}
		else if(a.getCodigo() > b.getCodigo())
		{
			return 1;
		}
		else
		{
			return 0;
		}

	});

	//NESSE FOR PASSAREMOS POR CADA DISCIPLINA
	listaDisciplinas.forEach(function(d)
	{
		//PEGAMOS A LISTA DE AVALIAÇÕES DA DISCIPLINA
		var lista = d.getListaAvaliacao();
		
		//E ORDENAMOS ELA
		lista = lista.sort(function(a,b) {return a-b});
		
		//PARA CADA ELEMENTO DA LISTA DE AVALIAÇÕES DA DISCIPLINA
		lista.forEach(function(ava)
		{
			//SE NÃO FOR PROVA FINAL
			if(ava.getTipo() != "F")
			{
				console.log(d.getCodigo()+";"+ava.getCodigoAvaliacao()+";"+ava.getNome()+";"+ava.getData()+";"+ava.mediaAlunos().toFixed(2).replace('.', ',')+"\n");
				
				//ADICIONA O CONTEÚDO A SER IMPRESSO NO ARQUIVO.CSV
				arquivoCSV += (d.getCodigo()+";"+ava.getCodigoAvaliacao()+";"+ava.getNome()+";"+ava.getData()+";"+ava.mediaAlunos().toFixed(2).replace('.', ',')+"\n");
			}
		});
	});

	//CRIA TIPO UMA URL
	var encodedUri = encodeURI(arquivoCSV);

	//CRIA UM LINK
	var link = document.createElement("a");
	link.setAttribute("href", encodedUri);

	//ATRIBUI O NOME DO ARQUIVO A SER SALVO
	link.setAttribute("download", "3-avaliacoes.csv");
	
	//GERA O ARQUIVO.CSV
	link.click();

}		


//EXECUTA O PROGRAMA
function main()
{

	ajudaNaImpressao();

	estatisticaAvaliacao();









}
